// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// - protoc-gen-go-grpc v1.3.0
// - protoc             v3.20.3
// source: proto/encryption.proto

package interfaces

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

const (
	Encryption_Exchange_FullMethodName = "/listener.Encryption/Exchange"
)

// EncryptionClient is the client API for Encryption service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type EncryptionClient interface {
	Exchange(ctx context.Context, in *ExchangeRequest, opts ...grpc.CallOption) (*ExchangeResponse, error)
}

type encryptionClient struct {
	cc grpc.ClientConnInterface
}

func NewEncryptionClient(cc grpc.ClientConnInterface) EncryptionClient {
	return &encryptionClient{cc}
}

func (c *encryptionClient) Exchange(ctx context.Context, in *ExchangeRequest, opts ...grpc.CallOption) (*ExchangeResponse, error) {
	out := new(ExchangeResponse)
	err := c.cc.Invoke(ctx, Encryption_Exchange_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// EncryptionServer is the server API for Encryption service.
// All implementations must embed UnimplementedEncryptionServer
// for forward compatibility
type EncryptionServer interface {
	Exchange(context.Context, *ExchangeRequest) (*ExchangeResponse, error)
	mustEmbedUnimplementedEncryptionServer()
}

// UnimplementedEncryptionServer must be embedded to have forward compatible implementations.
type UnimplementedEncryptionServer struct {
}

func (UnimplementedEncryptionServer) Exchange(context.Context, *ExchangeRequest) (*ExchangeResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Exchange not implemented")
}
func (UnimplementedEncryptionServer) mustEmbedUnimplementedEncryptionServer() {}

// UnsafeEncryptionServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to EncryptionServer will
// result in compilation errors.
type UnsafeEncryptionServer interface {
	mustEmbedUnimplementedEncryptionServer()
}

func RegisterEncryptionServer(s grpc.ServiceRegistrar, srv EncryptionServer) {
	s.RegisterService(&Encryption_ServiceDesc, srv)
}

func _Encryption_Exchange_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ExchangeRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(EncryptionServer).Exchange(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Encryption_Exchange_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(EncryptionServer).Exchange(ctx, req.(*ExchangeRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// Encryption_ServiceDesc is the grpc.ServiceDesc for Encryption service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Encryption_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "listener.Encryption",
	HandlerType: (*EncryptionServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Exchange",
			Handler:    _Encryption_Exchange_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "proto/encryption.proto",
}
